#!/bin/bash

[ ! -f "/opt/aggregator/setup.ini" ] && exit;

. /opt/aggregator/setup.ini

SERVERS=();

GET_SERVERS()
{
	local COMMENT="#*"
	while read SNAME
	do
		SERVERS+=(${SNAME%%${COMMENT}})	
	done < ${SERVERS_LIST}	
	
	[ "x${SERVERS[*]}" == "x" ] && exit;
}


RSYNC_COMMAND="/usr/bin/rsync"
LOG_CONVERTOR="/usr/local/bin/log_convert"

LOG="/var/log/sync.log"
NEW_LOG="N"

CHECK_FOLDERS()
{
	[ "x${LOCAL_AGGREGATOR_DIRECTORY}" == "x" ] && echo "error: unspecified: LOCAL_AGGREGATOR_DIRECTORY" && exit 1
	[ ! -d ${LOCAL_AGGREGATOR_DIRECTORY} ] && mkdir -p "${LOCAL_AGGREGATOR_DIRECTORY}"
	[ ! -d ${LOCAL_AGGREGATOR_DIRECTORY} ] && echo "error: creating: LOCAL_AGGREGATOR_DIRECTORY: ${LOCAL_AGGREGATOR_DIRECTORY}" && exit 1
}


START_SYNC()
{
	s=${#SERVERS[@]}
	for (( i=0; i<s; i++))
	do
		local RSYNC=();
		local SOURCE=${SERVERS[$i]}
		local DEST=${LOCAL_AGGREGATOR_DIRECTORY}/${SOURCE}/${EXTENDED_LOG_SUB_FOLDER}
		[ ! -d ${DEST} ] && mkdir -p "${DEST}"
		[ ! -d ${DEST} ] && echo "failed to create: ${DEST}" && continue;
		mkdir -p ${LOCAL_AGGREGATOR_DIRECTORY}/${SOURCE}/${ACCESS_LOG_SUB_FOLDER}/
		
		RSYNC+=(${RSYNC_COMMAND})
		RSYNC+=("--append")
		RSYNC+=("--compress")
		RSYNC+=("--times")
		RSYNC+=("--archive")
		RSYNC+=("--no-links")
		RSYNC+=("--info=FLIST")
		RSYNC+=("--log-file=${DEST}/.journal")
#		RSYNC+=("--verbose")
		
		cat <<- _EOF
		${RSYNC[*]} -e "ssh -i ${KEY_STORE}/${SSH_KEY}" ${SYNC_USER}@${SOURCE}:${REMOTE_LOG_DIRECTORY} ${DEST}
		_EOF
		${RSYNC[*]} -e "ssh -i ${KEY_STORE}/${SSH_KEY}" ${SYNC_USER}@${SOURCE}:${REMOTE_LOG_DIRECTORY} ${DEST}
		
		echo "RSYNC: $SOURCE: $?"
	done
}

MAIN()
{
	date >> ${LOG}
	GET_SERVERS
	CHECK_FOLDERS
	START_SYNC
}

MAIN

exit

# rsync --append -zta --no-links -vze ssh root@192.168.250.148:/var/log/safesquid/extended/ /home/nonsense/